Bug 39024 - [Pineview webgl] many webgl conformance cases crash the browser
[Pineview webgl] many webgl conformance cases crash the browser
Status: VERIFIED FIXED
Product: Mesa
Classification: Unclassified
Component: Drivers/DRI/i915
git
x86 (IA32) Linux (All)
: high major
Assigned To: Ian Romanick
:
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2011-07-07 01:27 UTC by zhao jian
Modified: 2011-07-20 19:20 UTC (History)
0 users

See Also:
i915 platform:
i915 features:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description zhao jian 2011-07-07 01:27:04 UTC
System Environment:
--------------------------
Libdrm:		(master)2.4.26
Mesa:		(master)3fccc14b2fb35aef95bc04dee46e280a48679299
Xserver:		(master)xorg-server-1.10.2.902
Xf86_video_intel:(master)2.15.0-163-g98f2e3855d70c02b05e2721a70ebce0c17e44283
Cairo:		(master)d7cc30eb0112010533d05b4579a12e7a2910b08d
Libva:		(master)5343740dfec289858cfafda64dd5260179d09d4f
Kernel:	(drm-intel-next) a7f08958d7ca69e26ec85fe49c0be3568a565493

Bug detailed description:
-------------------------
Tested with chrome14(14.0.784.0), There are 15 webgl conformance tests will make the webpage crash(the chrome still alive) everytime with the following error messages. This issue only existed on Pineview. It works well with software rasterization. 

i915_program_error: Bad inst->DstReg.Index: 3
hrome-linux/chrome --type=gpu-process --channel=15168.0xbde0480.1530218914: i915_program.c:248: i915_emit_texld: Assertion `dest == ((((((dest)>>29)&0x7))<< 29) | (((((dest)>>24)&0xf)) << 24) | (0 << 20) | (1 << 16) | (2 << 12) | (3 << 8) | (4 << 4) | (5 << 0))\' failed.

some affected cases are: 
conformance/context-lost-restored.html
conformance/context-lost.html
conformance/copy-tex-image-and-sub-image-2d.html
conformance/gl-clear.html
conformance/gl-teximage.html
conformance/read-pixels-test.html
conformance/tex-image-and-sub-image-2d-with-array-buffer-view.html
conformance/tex-image-and-sub-image-2d-with-image-data.html
conformance/tex-image-and-sub-image-2d-with-video.html
conformance/texture-active-bind.html
conformance/texture-complete.html              
conformance/texture-formats-test.html
conformance/texture-npot.html
conformance/texture-transparent-pixels-initialized.html


Reproduce steps: 
--------------------------
1. download webglc test suite from 
https://cvs.khronos.org/svn/repos/registry/trunk/public/webgl/sdk/tests/ 
2. use chrome run the test
Comment 1 Eric Anholt 2011-07-12 16:02:18 UTC
commit 556a47a2621073185be83a0a721a8ba93392bedb
Author: Eric Anholt <eric@anholt.net>
Date:   Tue Jul 12 15:31:39 2011 -0700

    i915: Add support for gl_FragData[0] for output color.
    
    We advertised ARB_draw_buffers, but either fell back to software when
    using this output, or assertion failed.  Fixes glsl-fs-fragdata-1, and
    failures in some webgl conformance tests.
    
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=39024
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=34906
Comment 2 zhao jian 2011-07-20 19:20:01 UTC
verified with the newest code. 
Libdrm:         (master)2.4.26-1-g8d055890d90c3d92647e3d8b98d32630ef87c2c8
Mesa:           (master)8d044047f133ad4e4c4f1f6b4a4a1c4a9fa477f5
Xserver:                (master)xorg-server-1.10.99.901-115-g73864a87aacbce85b520ccaa6e360b82c0e99716
Xf86_video_intel:               (master)2.15.0-204-g3e55f3e88b40471706d5cd45c4df4010f8675c75
Cairo:          (master)4fd20fe903ebd698ec6d6fe0741d3dffb4eca74f
Libva:          (master)270299fc541c9f78efc43f1e87f6b7efd5373ec1
Kernel:         (drm-intel-next)6e96e7757a0133a9a66fd9b86cd04b5e7b88122a